DirectOut M.1K2 Firmware ReadMe, 2020-07-31


=== 2020-07-31 (requires Update 2019-04-07 being installed first)
 - BUGFIX: port assignment of primary fallback configuration for clock redundancy did not work properly


=== 2019-04-07
 - updated GPL license information


=== 2018-11-09
 - BUGFIX: if a user has no permission to run system scripts, the panel will not show
 - BUGFIX: editing users could have led to the browser tab being stuck in an endless loop
 - BUGFIX: follow_96k was broken in a previous update, fixed
 - upgrade file verification speed up
 - added 'safe click' mode to channel matrix ('j' key to enable/disable)


=== 2018-09-19
 - BUGFIX: telnetd: BULK Commands did not work properly <- fixed


=== 2017-10-18
 - SW-P 08: added live debugging
 - SW-P 08: matrix IDs freely configurable
 - Improved Tally handling
 - SW-P 08: added system snapshot and system script matrix
 - SW-P 08: added Label im-/export
 - improved label import/export help page
 - luad: added telnettx, tcptx, udptx, sertx
 - added separate system script window
 - BUGFIX: Doppelgaenger slave discovery
 - BUGFIX: Watchdog did not restart httpd anymore since 2017-08-09
 - BUGFIX: multi-line comments in snapshots got cut off
 - BUGFIX: some special characters in channel labels were not masked
properly


=== 2017-09-12
- BUGFIX from 2017-08-29 introduced another bug, fixed



=== 2017-08-30
 - NEW: service web page running with autonomous webserver on port 8080
 - BUGFIX: Masking of " missing in function that displays the currently
active snapshot
 - BUGFIX: snapshots which changed FS might have had not all XPs restored



=== 2017-06-09
- added check of gateway IP (which is mandatory in manual IP configuration)
- added warning if IP reset is disabled
- added tally functionality to scripts
- BUGFIX: large config backup generation could lead to browser time
out while waiting for download; now generating uncompressed
configuration backup archives
- remove PORTGAIN_MODE command from telnet
- added SYSTEM_SCRIPT to telnet



=== 2017-05-03
- bit transparency mode (switchable per port)
- 57ch mode was sometimes greyed out and not switchable manually <- fixed


	
=== 2017-03-17
 - delayed network configuration to a point after initialization
 - added MIDI controller B8 to run system scripts
 - improved transaction speed on audio xp lock & gain lock



=== Update 2017-02-23
 - fixed display problem of port/serial/MIDI matrix on hiDPI displays
 - fixed display problem of MADI channels in port configuration page
 - added workaround for update problem in port matrix after loading a snapshot



=== Update 2017-02-08
 - added "raw number" label mode in channel matrix
 - added salvo generator for scripts (BETA)
 - BUGFIX in controld
 - BUGFIX in httpd
 - typo removal in online help
 - BUGFIX: snapshot buttons in matrix pages were inaccessible
 - fixed several typos in online help 
 


=== Update 2017-02-01
 - fixed output of telnet daemon (0 byte, 2 typos)
 - "Plugin Configuration" page added to online help, was missing
 - added fallback mode to fan controller
 - BUGFIX: linux kernel's w1_therm driver could segfault 
 - BUGFIX: three byte SysEx messages entered in MIDI tool were not transmitted



=== Update 2016-12-14
 - improved storage of device registration data (gen2 controller only)
 - removed bug that toggled DONET daemon to disabled state after booting
 - port configuration page now remembers last selected port
 - system script tab added to mobile page
 - fixed a bug in the CSV routing export function



=== Update 2016-11-28
- Display error in Channel Matrix overview display <- fixed
- smart SFP.IO board support added 

LUA Scripting Engine (BETA):
- formatting in scripting help fixed
- missing scripting directory added 



=== Update 2016-11-04
 - channel matrix: label display mode notification on change of display mode
 - bugfix: channel matrix toggling offline/online matrix did not work anymore <- fixed
 - BETA: LUA scripting engine (public Beta) <- not yet recommended for use in productive environments.



=== Update 2016-11-04
 - channel matrix: label display mode notification on change of display mode
 - bugfix: channel matrix toggling offline/online matrix did not work anymore <- fixed
 - BETA: LUA scripting engine (public Beta) <- not yet recommended for use in productive environments.



=== Update 2016-10-26
 - removed time jump feature from sync daemon
 - added CLEAR button to port sync history
 - added 57ch support (black series only)
 - bugfix json/xps_set, source/dest were swapped



=== Update 2016-06-01
 - new feature: port matrix to SWP08
 - new feature: configurable audio matrix
 - bugfix regarding network configuration storage in green series



=== Update 2016-05-12 (black panel devices only) === 
 
 - bugfix user login statistics on black series
 - bugfix user snapshots on black series



=== Update 2016-03-25 (black panel devices only) ===

 - bugfix in telnet's PORTXP command
 - bugfix in port configuration page
 - cleaned up plugin handling
 - cleaned up ethernet initialization
 - added AUDIODI, AUDIOSI, AUDIOSO, FEEDBACK to telnet



=== Update 2016-01-17 (black panel devices only) ===

 - SNMP support
 - MIDI Matrix / Serial Matrix: Display for serial and MIDI data activity
 - donetd broke support archive generation <- fixed
 - truncation of incomplete UTF8 sequences in labels added
 - MIDI Tool: illegal MIDI commands were not marked as such <- fixed


=== Update 2015-11-19 ===
 
 - FPGA firmware build 03 fixes issue indicating video mode
 - Controller kernel update to fix issue with MIDIoverMADI


=== Update 2015-10-27 ===
 
 - fixed a bug regarding non-admin users wanting to store a snapshot


=== Update 2015-09-30 (black panel devices only) ===
 
 - Bug in MAC Address configuration <- fixed
 - Changes in MIDI self test
 - fixed the MIDI self test
 - added a driver for Pre-v10 Windows to make use of the USB serial port


=== Update 2015-09-22 ===

 - fixed a bug in midid that could lead to repeated the last sysex packet
 - MIDI connectivity to the controller was lost (black panel only), fixed  
 - fixed a bug concerning not connected XPs in offline matrix
 - fixed a bug concerning labels with exactly 16 characters length


=== Update 2015-06-25 ===

 - fixed a bug creating new users (black panel only)
 - fixed a bug concerning deletion of a user's snapshots (black panel only)
 - speedup of boot process 70s -> 12s (black panel only)


=== Update 2015-04-24 ===

 - FPGA firmware fix to correctly indicate video input state
 - rearranged order of snapshot data to speed up loading
 - fixed compatibility issue with Safari and Matrix View
 - added serial variant of SWP08 daemon
 - added fix for 4-wire fans
 - last snapshot loaded displayed in status bar
 - fixed www logout issue
 - added clock hierarchy
 - added AES word clock input (rev 2 FPGA boards only)


=== Update 2014-11-27 ===

- fixed issue with temperature measurement (tempd)


=== Update 2014-10-19 ===

- 'Silent Mode' added: Shut down fans completely
- faster startup of fan control
- added new dual controller status flags to enhance compatibility with
newer VSM versions
- Doppelgaenger
- If the RESET button is pressed for more than 1s (but less than 5s), the
web server is restarted
- After changing the network setting, the web page relocates to the new
address
- Native DONet support added: Remotely control all D.O. devices that
are connected to the M.1k2
- added third layer of labels in Matrix view: Output labels display the
input label once a connection is made, "N/C" otherwise
- CSV export of routing and clock assignment
- 96k-Follow added


=== Update 2014-06-12 ===
Release Version

- Enhanced compatibility of native MADI receiver
- FPGA Firmware 93

=== Update 2014-05-12 ===
Release Version

- improved “Channel Routing” panel in port page

- fixed issue with passwords containing special characters in login mask

- fixes a bug where user permissions seems to ‘vanish’ until the next reboot after editing user accounts.

=== Update 2014-05-02 ===
Release Version

- Fixes a bug that truncated backup and support archives when being
transferred over very slow connections

- This update should be installed by all users who installed the ‘Xaver’
firmware or any other version later than 2013-12-05

- Please create fresh backup files AFTER installing this firmware.
Backup files created between 2013-12-05 and this firmware might be
defective.

[- You can test your backup files by opening them with an archive tool
that can handle .tar.bz2 files, e.g. Winzip.]

=== Update 2014-03-27 ===
Release Version*

Changes:
- temporary permissions can be taken exclusively by a user
- improved syslog messages

Bugfixes:
- Quick Shots could not be deleted on OS X <- fixed
- some minor bug fixes

* The update consists of two files. Part 1 performs the software update. Part 2 contains the new help manual. It is crucial that Part 1 is installed first.

=== Update 2014-01-22 ===
Release Version*

- Label Import: Added automatic detection and conversion of character sets
- Port Matrix: Protection of mixed port connections - now requires SHIFT-Click
- JSON daemon: Enhanced functionality
- Offline Manual: Updated version
- Some other small enhancements and bugfixes

=== Update 2013-12-05 (‘Xaver’) ===
Release Version*

- User Management with Permission Classes
- Gain Map: individual output gains for each channel
- System Snapshots: Snapshots can be assigned to a system wide ID and triggered by a MIDI command
- MIDI daemon: Remote control of routing, snapshots and configurations via MIDI
- JSON daemon: Remote control of routing and system state via JSON
- Sync History display
- MIDI tool: Test tool for incoming and outgoing MIDI data
- Reworked interactive help manual
- Many other small enhancements and bugfixes

* The update consists of two files. Part 1 performs the software update. Part 2 contains the new help manual. It is crucial that Part 1 is installed first.

=== Hotfix 2013-06-13
Cumulative Hotfix of Firmware Version 03.03.2012 - includes hotfix 2013-02-11

Resolved issues:
- cookie value parser
- display problem in monitoring tool when using 2 FS/4 FS
- swp08d was not started by default
- adressing of serial/MIDI matrix
- firmware update redirect was broken
- display problem with current FireFox versions in the channel matrix
- 56ch/64ch mode setting was not stored correctly

=== Hotfix 2013-02-11 ===
Hotfix of Firmware Version 03.03.2012

Resolved issues:
- Display problem with current FireFox versions in the channel matrix        
- SWP08 daemon was not started under all circumstances
- 56ch/64ch mode setting was not stored correctly

=== Update 2012-02-24 ===

*** FPGA: Firmware build 87

*** System
New features:
- Channel matrix: “commit” secured with shift+click or safety requester
- Setup-Tool: Hostname and MAC address display at DHCP explanation
- Self test: Temperature readout and slot status added
- Added compensation for leaps in system time caused by NTP
- If system differs more than 10000s from client time, the system clock is adjusted
- Channel matrix: Quickshots
- Status popups show port name
- Port config: Port number displayed in title
- Color labels for ports
- Channel matrix: Port name displayed three times to increase readability
- Expert mode for port labels
- Channel matrix: Border between ports added
- Clock configuration: “Follow port” function
- WCK: NEW: Master clock section
- WCK: NEW: Word clock MUL selection
- WCK: NEW: “Follow clock” function
- Status: NEW: Added current MUL to port and WCK popup
- WCK config: WCK input frequency displayed when signal is only locked
- WCK config: Detailed status for all ports
- Port configuration: Cleanup
- Port configuration: Added Follow Port and Master clock features
- User menu added
- Snapshot managment added
- WCK: Added “out of safe range” indicator at WCK in status


Resolved issues:
- Snapshot restore uses correct locking/unlocking sequence
- Setup wizard didn’t store DNS address if only one was given
- httpd crashed when loading old user profiles
- MAC address was not set correctly in DHCP mode
- Channel matrix: Mousewheel scrolling in help window doesn’t scroll matrix view anymore
- Channel matrix: Map overview cursor positioning fixed
- httpd: Improved error handling (404)
- Setup wizard: DNS2 was zeroed 
- Port matrix: fader range corrected, fader behaviour fixed
- Dump command: fixed bug in sync timeout display
- Support script: Typo
- Serial bitrates were not restored upon startup
- mdns responder sends out static IP when using DHCP


=== Update 2011-12-11 ===

*** FPGA: Firmware build 70

*** System
New features:
- Channel matrix: Snapshot/Recall stores matrix, locks, labels and gains in downloadable file
- Network: Services are announced via mDNS, speeds up device location after network changes/reboot


=== Update 2011-11-30 ===

*** System
Resolved issues:
- Fixed a bug in the web server which caused to stall connections when editing labels


=== Update 2011-11-25 ===
*** FPGA: Firmware build 64

*** System
New features:
- Config: Restore configuration archive added
- Config: Restore User profile added
- Config: added wipe user data
- Added “My Profile” page
- My Profile: Added user archive/restore
- My Profile: Added password modification
- Added fixed menu option (fix the menu bar)
- Channel matrix: Added custom cursor for OOR regions (Out of range)
- Channel matrix: ‘i’ shows info floater
- Channel matrix: ‘a’ switches between diagonal and horizontal stencil
- Channel matrix: Added yellow markers to indicate different speed modes, 56ch mode
- Channel matrix: Added red markers to indicate locked channels
- Port matrix: added shift+click to the lock row
- Help: next/previous navigation added
- Help: “Quick start” section updated
- Help: “Frontpanel” section added
- Help: “Port matrix” page updated
- Help: “Channel matrix” page added
- Help: “Menu page” added
- Help: “Status page” added
- Service page: Added slot power switch

Resolved issues:
- Channel matrix: Fixed offline matrix handling
- Channel matrix: Improved “clear matrix” speed
- Channel matrix: Fixed behaviour for OOR regions
- Channel Matrix: Commit now only possible in offline mode
- Channel Matrix: Toolbox keys disabled during label editing
- Channel Matrix: Map rectangle was not drawn initially, only after repositioning the map
- Channel Matrix: Map behaviour in Firefox fixed, but no more dragging (just clicking)
- Channel Matrix settings for labels and which matrix to use are persistent now
- Channel Matrix now checks for valid login
- Channel Matrix: Bug that displayed new XPs from hidden matrix removed
- Port Matrix: Display of ‘NaN’ port gain values removed when loading page for the first time
- MIDI matrix: Fixed yellow coloring when moving over the matrix
- Removed bug that turned on PolySync after cold boot
- Fixed bug when restoring PolySync sources on cold boot (all references were set to wck input reference)
- Fixed bug that displayed the user ID after logout
- Fixed password reset
- Login: double display of login prompt removed when loading page for the first time 
- Fixed a bug where the network configuration files weren’t overwritten when setting factory defaults


=== Update 2011-10-11 ===
- Fixed label editing with FireFox 7


=== Update 2011-09-30 ===
*** FPGA: Firmware build 59


